<?

/*
	Solve sudoku's online.

        (C) Copyright 2006 by Mogens Kjaer, mk@lemo.dk

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful, 
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License 
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

include('utilities.php');

sudoku_db();

function errorexit($dan, $eng)
{
  global $lang;
  echo "<HTML>\n";
  echo "<HEAD>\n";
  echo "  <META HTTP-EQUIV=\"content-type\" CONTENT=\"TEXT/HTML; CHARSET=ISO-8859-1\">\n";
  echo "  <META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW\">\n";
  if($lang==0)
    echo "  <TITLE>Sudoku lser</TITLE>\n";
  else
    echo "  <TITLE>Sudoku solver</TITLE>\n";
  echo "</HEAD>\n";
  echo "<body style=\"background-color: white\">\n";

  if($lang==0)
  {
    echo "<h1>Fejl!</h1>\n";
    echo "<p>".$dan."</p>\n";
    echo "Klik <A HREF=\"javascript:history.back(-1)\">tilbage</a> og ret fejlen.</p>\n";
  }
  else
  {
    echo "<h1>Error!</h1>\n";
    echo "<p>".$eng."</p>\n";
    echo "Click <A HREF=\"javascript:history.back(-1)\">back</a> and correct the error.</p>\n";
  }
  echo "</body>\n";
  echo "</html>\n";
  exit;
}

if(!isset($serial))
{
  errorexit("Opgave nummer mangler.", "No puzzle number specified.");
}

$res1 = mysql_query("select * from sudoku where serial=".intval($serial));
if($row1 = mysql_fetch_assoc($res1))
{
    $nx = $row1["nx"];
    $ny = $row1["ny"];
}
else
{
  errorexit("Opgave ".$serial." findes ikke.", "Puzzle no. ".$serial." does not exist.");
}

$res2 = mysql_query("update sudoku set lastused=now() where serial=".intval($serial));

$nxny = $nx*$ny;
$kludge = $ny*2-2;

$res2 = mysql_query("select * from solutions where serial=".$row1["serial"]);
if($row2 = mysql_fetch_assoc($res2)) $thissolution = $row2["solution"];
$res2 = mysql_query("select * from problems where serial=".$row1["serial"]);
if($row2 = mysql_fetch_assoc($res2)) $thisproblem = $row2["problem"];

echo "<HTML>\n";
echo "<HEAD>\n";
echo "  <META HTTP-EQUIV=\"content-type\" CONTENT=\"TEXT/HTML; CHARSET=ISO-8859-1\">\n";
echo "  <META NAME=\"ROBOTS\" CONTENT=\"NOFOLLOW\">\n";
if($lang==0)
  echo "  <TITLE>Sudoku lser</TITLE>\n";
else
  echo "  <TITLE>Sudoku solver</TITLE>\n";
echo "<script type=\"text/javascript\">\n";
echo "problem=\"".$thisproblem."\";\n";
echo "solution=\"".$thissolution."\";\n";
echo "nx=".$nx.";\n";
echo "ny=".$ny.";\n";
echo "SYMBOLLIST=\"".$SYMBOLLIST."\";\n";
echo "lang=".$lang.";\n";
echo "kludge=".$kludge.";\n";
?>

/*	Suggestions and improvements from UMM, Singapore. 	*/

nxny=nx*ny;
cstatus = new Array(nxny);
corig = new Array(nxny);
csolution = new Array(nxny);
nfilled=0;
nempty=0;
nbad=0;

starttime=new Date();
lastclick=new Date();
clicked=0;

lastr1=0;
lastc1=0;
lastr2=0;
lastc2=0;

/*
	The possible array:

	0  not possible from start
	+1 possible from start
	+2 eliminated by setting a number to solution
	+4 eliminated by user

*/

possible = new Array(nxny);

function init()
{
  var i,r1,c1,r2,c2,r3,c3;

  i=0;
  for(r1=0; r1<nxny; r1++)
  {
    cstatus[r1] = new Array(nxny);
    corig[r1] = new Array(nxny);
    csolution[r1] = new Array(nxny);
    possible[r1] = new Array(nxny);
    for(c1=0; c1<nxny; c1++)
    {
      possible[r1][c1] = new Array(nxny);
      cstatus[r1][c1] = SYMBOLLIST.indexOf(problem.charAt(i));
      csolution[r1][c1] = SYMBOLLIST.indexOf(solution.charAt(i));
      corig[r1][c1] = cstatus[r1][c1];
      i++;
    }
  }
  for(r1=0; r1<nxny; r1++)
  {
    for(c1=0; c1<nxny; c1++)
    {
      /* All are possible: */
      for(i2=0;i2<nxny;i2++)
      {
	possible[r1][c1][i2] = 1;
      }
      if(document.param.showpossible.checked)
      {
	if(cstatus[r1][c1]>0)
	{
	  for(i2=0;i2<nxny;i2++)
	  {
	    possible[r1][c1][i2] = 0;
	  }
	}
	else
	{
	  /* Remove row */
	  for(c2=0;c2<nxny;c2++)
	  {
	    if(cstatus[r1][c2]>0)
	    {
	      possible[r1][c1][cstatus[r1][c2]-1] = 0;
	    }
	  }
	  /* Remove column */
	  for(r2=0;r2<nxny;r2++)
	  {
	    if(cstatus[r2][c1]>0)
	    {
	      possible[r1][c1][cstatus[r2][c1]-1] = 0;
	    }
	  }
	  /* Remove box */
	  for(r2=0;r2<nx;r2++)
	  {
	    for(c2=0;c2<ny;c2++)
	    {
	      r3 = Math.floor(r1/nx)*nx+r2;
	      c3 = Math.floor(c1/ny)*ny+c2;
	      if(cstatus[r3][c3]>0)
	      {
		possible[r1][c1][cstatus[r3][c3]-1] = 0;
	      }
	    }
	  }
	}
      }
      updatecell(r1,c1);
    }
  }
  updatestatistics();
  t=setTimeout('starttimer()',500);
}

function starttimer()
{
  var now,diff,sec,min,hour,txt;
  var i,j,toprow;

  if(nempty>0 || nbad>0)
  {
    now=new Date();
    diff=Math.round((now.getTime()-starttime.getTime())/1000);

    sec = diff%60;
    min = Math.floor(diff/60)%60;
    hour = Math.floor(diff/60/60);

    txt = hour+":";
    if(min<10) txt += "0";
    txt += min+":";
    if(sec<10) txt += "0";
    txt += sec;

    document.getElementById('timer').innerHTML=txt;
    t=setTimeout('starttimer()',500);
  }
  else
  {
    /* Puzzle is solved */
    toprow = new Array(nxny);
    for(i=0; i<nxny; i++) toprow[i]=document.getElementById('c'+SYMBOLLIST.charAt(0)+SYMBOLLIST.charAt(i)).innerHTML;
    for(i=0; i<(nxny-1); i++)
    for(j=0; j<nxny; j++)
    {
      document.getElementById('c'+SYMBOLLIST.charAt(i)+SYMBOLLIST.charAt(j)).innerHTML=
        document.getElementById('c'+SYMBOLLIST.charAt(i+1)+SYMBOLLIST.charAt(j)).innerHTML;
    }
    for(i=0; i<nxny; i++) document.getElementById('c'+SYMBOLLIST.charAt(nxny-1)+SYMBOLLIST.charAt(i)).innerHTML=toprow[i];
    t=setTimeout('starttimer()',200);
  }
}

function updatecell(r1,c1)
{
  var r2,c2,i2,cell;
  if(cstatus[r1][c1]==0)
  {
    /* Show possibilities */
    cell = "<table class=\"s\" border=0>";
    for(r2=0; r2<nx; r2++)
    {
      cell += "<tr style=\"height: 18px;\">";
      for(c2=0; c2<ny; c2++)
      {
        i2=r2*ny+c2;
	if(possible[r1][c1][i2]==0)
	{
	  cell += "<td style=\"width: 18px;\">&nbsp;";
	}
	else
	{
	  if(possible[r1][c1][i2]>1)
	  {
	    /* strike out */
	    /* cell += "<td style=\"width: 18px; text-decoration: line-through;\" "; */
	    if(possible[r1][c1][i2]&4)
	    {
	      cell += "<td style=\"width: 18px; color: #FF80FF;\" ";
	    }
	    else
	    {
	      cell += "<td style=\"width: 18px; color: #808080;\" ";
	    }
	  }
	  else
	  {
	    cell += "<td style=\"width: 18px; font-weight: bold;\" ";
	  }
	  cell += "onclick='cellclick("+r1+","+c1+","+r2+","+c2+")'";
	  cell += " onselectstart='cell2("+r1+","+c1+","+r2+","+c2+")'";
	  cell += ">"+SYMBOLLIST.charAt(i2+1);
	}
      }
    }
    cell += "</table>";
  }
  else
  {
    /* Show solution as big digit */
    cell = "<table class=\"p\" border=0>";
    cell += "<tr><td style=\"width: "+(ny*18+kludge)+"px;\" onclick='cellclick("+r1+","+c1+",0,0)'";
    cell += " onselectstart='cell2("+r1+","+c1+",0,0)'";
    cell += ">"+SYMBOLLIST.charAt(cstatus[r1][c1])+"</table>";
  }
  document.getElementById('c'+SYMBOLLIST.charAt(r1)+SYMBOLLIST.charAt(c1)).innerHTML=cell;
}

function cellclick(r1,c1,r2,c2)
{
  if(lastr1==r1 && lastc1==c1 && lastr2==r2 && lastc2==c2 && clicked==1)
  {
    clicked=2;
    cell2(r1,c1,r2,c2);
  }
  else
  {
    clicked=1;
    setTimeout("cellclick2()", 500);
  }
  lastr1=r1;
  lastc1=c1;
  lastr2=r2;
  lastc2=c2;
}

function cellclick2()
{
  if(clicked!=2)
  {
    cell(lastr1,lastc1,lastr2,lastc2);
  }
  clicked=0;
}

function cell(r1,c1,r2,c2)
{
  var i2;
  i2=r2*ny+c2;
  if(cstatus[r1][c1]==0)
  {
    if(possible[r1][c1][i2]!=0)
    {
      possible[r1][c1][i2] = possible[r1][c1][i2]^4;
      updatecell(r1,c1);
    }
  }
}

function cell2(r1,c1,r2,c2)
{
  var i2,r3,c3,r4,c4;
  i2=r2*ny+c2;
  if(corig[r1][c1]==0)
  {
    if(cstatus[r1][c1]==0)
    {
      if(possible[r1][c1][i2]!=0)
      {
	cstatus[r1][c1] = i2+1;
	updatecell(r1,c1);
      }
    }
    else if(corig[r1][c1]==0)
    {
      cstatus[r1][c1]=0;
      updatecell(r1,c1);
    }

    if(document.param.updatepossible.checked)
    {
      /* Check row r1 for changes of possible */

      for(c3=0;c3<nxny;c3++)
      {
	if(c3!=c1)
	{
	  if(cellpossible(r1,c3)) updatecell(r1,c3);
	}
      }

      /* Check column c1 for changes of possible */

      for(r3=0;r3<nxny;r3++)
      {
	if(r3!=r1)
	{
	  if(cellpossible(r3,c1)) updatecell(r3,c1);
	}
      }

      /* Check box for changes of possible */

      for(r3=0;r3<nx;r3++)
      {
	for(c3=0;c3<ny;c3++)
	{
	  r4 = Math.floor(r1/nx)*nx+r3;
	  c4 = Math.floor(c1/ny)*ny+c3;
	  if(r1!=r4 || c1!=c4)
	  {
	    if(cellpossible(r4,c4)) updatecell(r4,c4);
	  }
	}
      }
    }
  }
  updatestatistics();
}

function updatestatistics()
{
  var r1,c1;

  nfilled=0;
  nempty=0;
  nbad=0;

  for(r1=0;r1<nxny;r1++)
  for(c1=0;c1<nxny;c1++)
  {
    if(cstatus[r1][c1]==0)
    {
      nempty++;
    }
    else
    {
      nfilled++;
      if(cstatus[r1][c1]!=csolution[r1][c1])
      {
        nbad++;
      }
    }
  }
  if(lang==0)
  {
    document.getElementById('nfilled').innerHTML=nfilled+" celler er udfyldte.";
    document.getElementById('nempty').innerHTML=nempty+" celler er tomme.";
    document.getElementById('nbad').innerHTML=nbad+" celler er forkerte!";
  }
  else
  {
    document.getElementById('nfilled').innerHTML=nfilled+" cells have been filled.";
    document.getElementById('nempty').innerHTML=nempty+" cells are empty.";
    document.getElementById('nbad').innerHTML=nbad+" cells are wrong!";
  }
}

function changeupdatepossible()
{
  var r1,c1,i;
  for(r1=0;r1<nxny;r1++)
  for(c1=0;c1<nxny;c1++)
  {
    for(i=0;i<nxny;i++)
    {
      possible[r1][c1][i] &= ~2;
    }
    if(document.param.updatepossible.checked)
    {
      cellpossible(r1,c1);
    }
    updatecell(r1,c1);
  }
}

function cellpossible(r1,c1)
{
  var cvalue,cvalue1;
  var r2,c2,r3,c3,updated;

  /*
  	Calculate the possible 2 values
	for cell r1,c1.

	Return true iff any value has changed
	(added or removed).
  */

  updated=0;

  for(cvalue=0;cvalue<nxny;cvalue++)
  {
    if(possible[r1][c1][cvalue]!=0)
    {
      occurs=0;
      cvalue1 = cvalue+1;

      /* Check row r1 for occurence of cvalue */

      for(c2=0;c2<nxny;c2++)
      {
	if(c2!=c1)
	{
	  if(cvalue1==cstatus[r1][c2]) occurs=2;
	}
      }

      /* Check column c1 for occurence of cvalue */

      for(r2=0;r2<nxny;r2++)
      {
	if(r2!=r1)
	{
	  if(cvalue1==cstatus[r2][c1]) occurs=2;
	}
      }

      for(r2=0;r2<nx;r2++)
      {
	for(c2=0;c2<ny;c2++)
	{
	  r3 = Math.floor(r1/nx)*nx+r2;
	  c3 = Math.floor(c1/ny)*ny+c2;
	  if(r1!=r3 || c1!=c3)
	  {
	    if(cvalue1==cstatus[r3][c3]) occurs=2;
	  }
	}
      }

      if((possible[r1][c1][cvalue]&2)!=occurs)
      {
	updated=1;
	possible[r1][c1][cvalue] ^= 2;
      }
    }
  }
  return updated;
}

<?
echo "</script>\n";
echo "</HEAD>\n";
echo "<body style=\"background-color: white\" onLoad=\"init()\">\n";

echo "<style>\n";
echo "table.s {height: ".($nx*18)."px; width: ".($ny*18)."px; font: 14px Helvetica, Sans-Serif; padding: 0px; cursor: pointer; table-layout: fixed; text-align: center; vertical-align: middle; border-width: 0px; border-collapse: collapse; border-spacing: 0; margin: 0 auto; line-height: 100%;}\n";
echo "table.p {height: ".($nx*18)."px; width: ".($ny*18+$kludge)."px; font: bold ".(12*min($nx,$ny))."px Helvetica, Sans-Serif; padding: 0px; cursor: pointer; table-layout: fixed; text-align: center; vertical-align: middle; border-width: 0px; border-collapse: collapse; border-spacing: 0; margin: 0 auto; line-height: 100%;}\n";
echo "</style>\n";

if($lang==0)
  echo "<h1>Opgave nr. ".$serial."</h1>\n";
else
  echo "<h1>Puzzle no. ".$serial."</h1>\n";

echo "<table border=0 cellpadding=10>\n";
echo "<tr><td>\n";
echo "<table style=\"table-layout: fixed; text-align: center; vertical-align: middle; font-size: 24pt; border-style: solid; border-width: 3px; border-color: black; border-collapse: collapse; border-spacing: 0; margin: 0 auto;\">\n";
$index=0;
for($i=0;$i<$nxny;$i++)
{
  echo "<tr style=\"height: ".($nx*18)."px\">";
  for($j=0;$j<$nxny;$j++)
  {
    echo "<td valign=middle style=\"width: ".($ny*18+2)."px; border-top: 1px solid black; border-right: 1px solid black; padding: 0; ";
    if(($i%$nx)==0 && $i>0) echo "border-top: 2px solid black; ";
    if((($j+1)%$ny)==0 && $j<($nxny-1)) echo "border-right: 2px solid black;";
    echo "\" id=\"c".substr($SYMBOLLIST,$i,1).substr($SYMBOLLIST,$j,1)."\">";
    echo "</td>\n";
    $index++;
  }
  echo "</tr>\n";
}
echo "</table>\n";
echo "<td valign=top>\n";
echo "<form name=param>\n";
echo "<input type=button onclick='init()' value=\"".($lang==0?"Forfra":"Restart")."\"><br><br>\n";
echo "<input type=checkbox name=showpossible checked onclick='init()'>";
if($lang==0)
{
  echo "Eliminr kandidater fra starten (genstarter)";
}
else
{
  echo "Eliminate candidates from the beginning (restarts)";
}
echo "<br><br>\n";
echo "<input type=checkbox name=updatepossible checked onclick='changeupdatepossible()'>";
if($lang==0)
{
  echo "Eliminr kandidater automatisk";
}
else
{
  echo "Eliminate candidates automatically";
}
echo "<br>\n";
echo "</form>\n";
echo "<p><div id=timer></div></p>\n";
echo "</table>\n";

echo "<p></p>\n";

echo "<div id=nfilled></div>\n";
echo "<div id=nempty></div>\n";
echo "<div id=nbad></div>\n";

if($lang==0)
{
  echo "<p>Klik p en kandidat for at eliminere, dobbeltklik for at vlge som lsning.</p>\n";
}
else
{
  echo "<p>Click on a candidate to eliminate it, double-click to select as a solution.</p>\n";
}

echo "</body>\n";
echo "</html>\n";
?>
