<?

/*

	Utility functions.

        (C) Copyright 2005 by Mogens Kjaer, mk@lemo.dk

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful, 
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License 
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/*
	Set up language
*/

$lang = 1; /* Default is English */
if(isset($HTTP_ACCEPT_LANGUAGE))
{
  $langs=explode(",",$HTTP_ACCEPT_LANGUAGE);
  foreach ($langs as $value)
  {
    $choice=substr($value,0,2);
    if($choice=="da")
    {
      $lang=0;
      break;
    }
    else if($choice=="no")
    {
      $lang=0;
      break;
    }
    else if($choice=="sv")
    {
      $lang=0;
      break;
    }
    else if($choice=="en")
    {
      $lang=1;
      break;
    }
  }
}

function level_text($level)
{
  global $lang;
  switch($lang)
  {
  case 0:
    switch($level)
    {
    case 0:
      return "Meget nem";
      break;
    case 1:
      return "Nem";
      break;
    case 2:
      return "Medium";
      break;
    case 3:
      return "Svr";
      break;
    case 4:
      return "Meget svr";
      break;
    }
    break;
  case 1:
    switch($level)
    {
    case 0:
      return "Very easy";
      break;
    case 1:
      return "Easy";
      break;
    case 2:
      return "Medium";
      break;
    case 3:
      return "Hard";
      break;
    case 4:
      return "Difficult";
      break;
    }
    break;
  }
}

function symmetrical_text($symmetrical)
{
  global $lang;
  switch($lang)
  {
  case 0:
    switch($symmetrical)
    {
    case 0:
      return "Ingen";
      break;
    case 1:
      return "X og y spejling";
      break;
    case 2:
      return "180".chr(176)." rotation";
      break;
    }
    break;
  case 1:
    switch($symmetrical)
    {
    case 0:
      return "None";
      break;
    case 1:
      return "X and y mirror";
      break;
    case 2:
      return "180".chr(176)." rotation";
      break;
    }
    break;
  }
}

function sudoku_db()
{
  global $lang;
  if(!mysql_pconnect("localhost","sudoku","sudoku"))
  {
    echo "<HTML>\n";
    echo "<HEAD>\n";
    echo "<title>Error</title>\n";
    echo "</head>\n";
    echo "<body>\n";
    if($lang==0)
    {
      echo "<h1>Intern fejl</h1>\n";
      echo "<p>Der er ingen forbindelse til MySQL serveren.</p>\n";
      echo "<p>Dette kan skyldes, at der tages backup af databasen.</p>\n";
      echo "<p>Prv igen lidt senere.</p>\n";
    }
    else
    {
      echo "<h1>Internal error</h1>\n";
      echo "<p>There is no connection to the MySQL server.</p>\n";
      echo "<p>This could happen during backup of the database.</p>\n";
      echo "<p>Please try again later.</p>\n";
    }
    echo "</body>\n";
    echo "</html>\n";
    exit;
  }
  mysql_select_db("sudoku");
}

function find_possibilities($nx, $ny, $row, $col, $problem, &$possibilities)
{
  global $SYMBOLLIST;
  /* find possibilities for cell ($row,$col), and
     return them in the array $possibilities */

  $possibilities = array();

  $nxny = $nx*$ny;

  /* Start with everything is possible */

  for($i=1; $i<=$nxny; $i++) $possibilities[$i] = 1;

  /* Remove from row */
  for($i=0; $i<$nxny; $i++)
  {
    $c = strpos($SYMBOLLIST, substr($problem, $row*$nxny+$i, 1));
    if($c>0) $possibilities[$c]=0;
  }

  /* Remove from col */
  for($j=0; $j<$nxny; $j++)
  {
    $c = strpos($SYMBOLLIST, substr($problem, $j*$nxny+$col, 1));
    if($c>0) $possibilities[$c]=0;
  }

  /* Remove from subcell */
  for($i=0; $i<$nx; $i++)
  for($j=0; $j<$ny; $j++)
  {
    $c = strpos($SYMBOLLIST, substr($problem, (floor($row/$nx)*$nx+$i)*$nxny+floor($col/$ny)*$ny+$j, 1));
    if($c>0) $possibilities[$c]=0;
  }
}

function logtext($p, &$txt)
{
  global $lang;
  switch(substr($p,0,1))
  {
  case 'A':
    if($lang==0)
    {
      $txt = sprintf("%s er den eneste kandidat i (%d,%d)",  substr($p,5,1), substr($p,1,2), substr($p,3,2));
    }
    else
    {
      $txt = sprintf("%s is the only candidate in (%d,%d)",  substr($p,5,1), substr($p,1,2), substr($p,3,2));
    }
    return 6;
  case 'B':
    if($lang==0)
    {
      $txt = sprintf("%s i (%d,%d) er den eneste kandidat rkke %d",  substr($p,7,1), substr($p,1,2), substr($p,3,2), substr($p,5,2));
    }
    else
    {
      $txt = sprintf("%s in (%d,%d) is the only candidate row %d",  substr($p,7,1), substr($p,1,2), substr($p,3,2), substr($p,5,2));
    }
    return 8;
  case 'C':
    if($lang==0)
    {
      $txt = sprintf("%s i (%d,%d) er den eneste kandidat sjle %d",  substr($p,7,1), substr($p,1,2), substr($p,3,2), substr($p,5,2));
    }
    else
    {
      $txt = sprintf("%s in (%d,%d) is the only candidate column %d",  substr($p,7,1), substr($p,1,2), substr($p,3,2), substr($p,5,2));
    }
    return 8;
  case 'D':
    if($lang==0)
    {
      $txt = sprintf("%s i (%d,%d) er den eneste kandidat kasse [%d,%d]",  substr($p,9,1), substr($p,1,2), substr($p,3,2), substr($p,5,2), substr($p,7,2));
    }
    else
    {
      $txt = sprintf("%s in (%d,%d) is the only candidate box [%d,%d]",  substr($p,9,1), substr($p,1,2), substr($p,3,2), substr($p,5,2), substr($p,7,2));
    }
    return 10;
  case 'E':
    if($lang==0)
    {
      $txt = sprintf("Udelukker %s fra (%d,%d) da den kun optrder i n kasse i rkke %d",  substr($p,7,1), substr($p,1,2), substr($p,3,2), substr($p,5,2));
    }
    else
    {
      $txt = sprintf("Eliminating %s from (%d,%d) because of single sector occurance in row %d",  substr($p,7,1), substr($p,1,2), substr($p,3,2), substr($p,5,2));
    }
    return 8;
  case 'F':
    if($lang==0)
    {
      $txt = sprintf("Udelukker %s fra (%d,%d) da den kun optrder i n kasse i sjle %d",  substr($p,7,1), substr($p,1,2), substr($p,3,2), substr($p,5,2));
    }
    else
    {
      $txt = sprintf("Eliminating %s from (%d,%d) because of single sector occurance in column %d",  substr($p,7,1), substr($p,1,2), substr($p,3,2), substr($p,5,2));
    }
    return 8;
  case 'G':
    if($lang==0)
    {
      $txt = sprintf("Udelukker %s fra (%d,%d) da den kun optrder i n rkke i kasse [%d,%d]",  substr($p,9,1), substr($p,1,2), substr($p,3,2), substr($p,5,2), substr($p,7,2));
    }
    else
    {
      $txt = sprintf("Eliminating %s from (%d,%d) because of single row occurance in box [%d,%d]",  substr($p,9,1), substr($p,1,2), substr($p,3,2), substr($p,5,2), substr($p,7,2));
    }
    return 10;
  case 'H':
    if($lang==0)
    {
      $txt = sprintf("Udelukker %s fra (%d,%d) da den kun optrder i n sjle i kasse [%d,%d]",  substr($p,9,1), substr($p,1,2), substr($p,3,2), substr($p,5,2), substr($p,7,2));
    }
    else
    {
      $txt = sprintf("Eliminating %s from (%d,%d) because of single column occurance in box [%d,%d]",  substr($p,9,1), substr($p,1,2), substr($p,3,2), substr($p,5,2), substr($p,7,2));
    }
    return 10;
  case 'I':
    $n=intval(substr($p,1,2));
    if($lang==0)
    {
      $txt = "Vrdierne";
      $txt1 = " lgger beslag p cellerne";
      $txt2 = " i en eller anden rkkeflge";
    }
    else
    {
      $txt = "The values";
      $txt1 = " occupy the cells";
      $txt2 = " in some order";
    }
    for($i=0;$i<$n;$i++)
    {
      $txt .= " ".substr($p,$i+3,1);
    }
    $txt .= $txt1;
    for($i=0;$i<$n;$i++)
    {
      $txt .= sprintf(" (%d,%d)", substr($p,$n+$i*4+3,2), substr($p,$n+$i*4+5,2));
    }
    $txt .= $txt2;
    return $n*5+3;
  case 'J':
    if($lang==0)
    {
      $txt = sprintf("Udelukker %s fra (%d,%d)",  substr($p,5,1), substr($p,1,2), substr($p,3,2));
    }
    else
    {
      $txt = sprintf("Eliminating %s from (%d,%d)",  substr($p,5,1), substr($p,1,2), substr($p,3,2));
    }
    return 6;
  case 'K':
    if($lang==0)
    {
      $txt = sprintf("Elimination ved hjlp af kandidater i en enkelt sektor gav os en kandidat: %s i (%d,%d)",  substr($p,5,1), substr($p,1,2), substr($p,3,2));
    }
    else
    {
      $txt = sprintf("The SSC elimination gave us a unique candidate: %s in (%d,%d)",  substr($p,5,1), substr($p,1,2), substr($p,3,2));
    }
    return 6;
  case 'L':
    if($lang==0)
    {
      $txt = sprintf("Elimination ved hjlp af usammenhngende delmngde gav os en kandidat: %s i (%d,%d)",  substr($p,5,1), substr($p,1,2), substr($p,3,2));
    }
    else
    {
      $txt = sprintf("The Disjoint Subset elimination gave us a unique candidate: %s in (%d,%d)",  substr($p,5,1), substr($p,1,2), substr($p,3,2));
    }
    return 6;
  case 'M':
    $n=intval(substr($p,1,2));
    if($lang==0)
    {
      $txt = sprintf("Gt: %d kandidater i (%d,%d):", $n, substr($p,3,2), substr($p,5,2));
    }
    else
    {
      $txt = sprintf("Guess: %d candidates in (%d,%d):", $n, substr($p,3,2), substr($p,5,2));
    }
    for($i=0;$i<$n;$i++)
    {
      $txt .= " ".substr($p,$i+7,1);
    }
    return $n+7;
  case 'N':
    if($lang==0)
    {
      $txt = sprintf("Resultat af gt: %s i (%d,%d)",  substr($p,5,1), substr($p,1,2), substr($p,3,2));
    }
    else
    {
      $txt = sprintf("Guess result: Using %s for (%d,%d)",  substr($p,5,1), substr($p,1,2), substr($p,3,2));
    }
    return 6;
  case 'O':
    $n=intval(substr($p,1,2));
    if($lang==0)
    {
      $txt = sprintf("%d kandidater i (%d,%d):", $n, substr($p,3,2), substr($p,5,2));
    }
    else
    {
      $txt = sprintf("%d candidates in (%d,%d):", $n, substr($p,3,2), substr($p,5,2));
    }
    for($i=0;$i<$n;$i++)
    {
      $txt .= " ".substr($p,$i+7,1);
    }
    return $n+7;
  case 'Y':
    if($lang==0)
    {
      $txt = "Ingen lsning";
    }
    else
    {
      $txt = "No solution";
    }
    return 1;
  case 'Z':
    if($lang==0)
    {
      $txt = "Slut";
    }
    else
    {
      $txt = "All done";
    }
    return 1;
  }
}


$SYMBOLLIST = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz";
?>
