#!/bin/bash

mysql -uroot -pyour_mysql_root_password mysql <<EOF
INSERT INTO db VALUES ('%','sudoku','sudoku','Y','Y','Y','Y','Y','Y','Y','Y','Y','Y');
INSERT INTO user VALUES ('localhost','sudoku',password('sudoku'),'N','N','N','N','N','N','N','N','N','N','N','N','N','N');
EOF

mysqladmin -uroot -pyour_mysql_root_password reload
mysqladmin -usudoku -psudoku -f drop sudoku 
mysqladmin -usudoku -psudoku create sudoku 

mysql -usudoku -psudoku sudoku <<EOF

--
-- Table structure for table `explanations`
--

DROP TABLE IF EXISTS `explanations`;
CREATE TABLE `explanations` (
  `serial` int(11) NOT NULL default '0',
  `explanation` text NOT NULL,
  PRIMARY KEY  (`serial`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1 MAX_ROWS=1000000000 AVG_ROW_LENGTH=366;

--
-- Table structure for table `problems`
--

DROP TABLE IF EXISTS `problems`;
CREATE TABLE `problems` (
  `serial` int(11) NOT NULL default '0',
  `problem` text NOT NULL,
  PRIMARY KEY  (`serial`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `solutions`
--

DROP TABLE IF EXISTS `solutions`;
CREATE TABLE `solutions` (
  `serial` int(11) NOT NULL default '0',
  `solution` text NOT NULL,
  PRIMARY KEY  (`serial`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `statistics`
--

DROP TABLE IF EXISTS `statistics`;
CREATE TABLE `statistics` (
  `notused` int(11) NOT NULL auto_increment,
  `nx` int(11) NOT NULL,
  `ny` int(11) NOT NULL,
  `ndigits` int(11) NOT NULL,
  `level` int(11) NOT NULL,
  `symmetrical` int(11) NOT NULL,
  `counter` int(11) NOT NULL,
  PRIMARY KEY  (`notused`),
  KEY `nx` (`nx`,`ny`),
  KEY `ndigits` (`ndigits`),
  KEY `level` (`level`),
  KEY `symmetrical` (`symmetrical`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

--
-- Table structure for table `sudoku`
--

DROP TABLE IF EXISTS `sudoku`;
CREATE TABLE `sudoku` (
  `serial` int(11) NOT NULL auto_increment,
  `inserted` timestamp NOT NULL default CURRENT_TIMESTAMP on update CURRENT_TIMESTAMP,
  `nx` int(11) NOT NULL default '0',
  `ny` int(11) NOT NULL default '0',
  `ndigits` int(11) NOT NULL default '0',
  `level` int(11) NOT NULL default '0',
  `symmetrical` int(11) NOT NULL default '0',
  `lastused` datetime default NULL,
  `abslevel` int(11) NOT NULL default '0',
  PRIMARY KEY  (`serial`),
  KEY `inserted` (`inserted`),
  KEY `nx` (`nx`,`ny`),
  KEY `ndigits` (`ndigits`),
  KEY `level` (`level`),
  KEY `symmetrical` (`symmetrical`),
  KEY `lastused` (`lastused`),
  KEY `abslevel` (`abslevel`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

EOF

