#!/usr/bin/perl

use DBI;
use Digest::MD5 qw(md5);

$dbh = DBI->connect("DBI:mysql:database=sudoku;host=localhost", "sudoku", "sudoku");

#
#	Get set of nx,ny,ndigits:
#
@nxnys = ();
$sth = $dbh->prepare("select nx,ny,ndigits,count(serial) from sudoku group by nx,ny,ndigits");
$sth->execute;
while($row = $sth->fetchrow_hashref)
{
  $nx = $row->{"nx"};
  $ny = $row->{"ny"};
  $ndigits = $row->{"ndigits"};
  push @nxnys, [$nx,$ny,$ndigits];
}

$totalnduplicates = 0;
$ntotalrecords = 0;

foreach $nxnyndigits ( @nxnys )
{
  $nx = $nxnyndigits->[0];
  $ny = $nxnyndigits->[1];
  $ndigits = $nxnyndigits->[2];
  $nduplicates = 0;
  $nrecords = 0;

  $sth = $dbh->prepare("select sudoku.serial,problems.problem from sudoku,problems where sudoku.nx=$nx and sudoku.ny=$ny and sudoku.ndigits=$ndigits and sudoku.serial=problems.serial");
  $sth->execute;

  $serials = {};
  @duplicates = ();

  while($row = $sth->fetchrow_hashref)
  {
    $ntotalrecords++;
    $nrecords++;
    $hash = md5($row->{"problem"});
    if(exists $serials->{$hash})
    {
      push @duplicates, $row->{"serial"};
      $nduplicates++;
      $totalnduplicates++;
    }
    else
    {
      $serials->{$hash} = $row->{"serial"};
    }
  }

  print "$nx $ny $ndigits: Removing $nduplicates out of $nrecords\n";

  foreach $serial (@duplicates)
  {
    $dbh->do("delete from sudoku where serial=$serial");
    $dbh->do("delete from problems where serial=$serial");
    $dbh->do("delete from solutions where serial=$serial");
    $dbh->do("delete from explanations where serial=$serial");
  }
}

print "$totalnduplicates duplicates out of $ntotalrecords sudokus.\n";
